
function dcl.PlayerLoaded(handle,t)
	dcl.LocationChanged();
	dcl.PlayerID = Inspect.Unit.Detail("player").id;
	Command.Event.Detach(Event.Unit.Availability.Full, dcl.PlayerLoaded, "dcl.PlayerLoaded");
end


function dcl.LocationChanged()
	dcl.Force = false;
	dcl.Reset();
end


function dcl.CoordsUpdate(handle,x,y,z)
	if x[dcl.PlayerID] == nil then return end;
	if dcl.TraceCoords then
		dcl.PlayerCoords.X = dcl.Round(x[dcl.PlayerID],4);
		dcl.PlayerCoords.Y = dcl.Round(y[dcl.PlayerID],4);
		dcl.PlayerCoords.Z = dcl.Round(z[dcl.PlayerID],4);
		dcl.TraceDimParameters();
		dcl.UpdateCoordsDisplay();
	end
end


function dcl.DimensionItemAdded(handler,item)
	if type(dcl.Restore_Co) == 'thread' then
		dcl.UpdateSnapshotID(item);
		coroutine.resume(dcl.Restore_Co);
	end
end


function dcl.DimensionItemRemoved(handler,item)
	if type(dcl.Remove_Co) == 'thread' then coroutine.resume(dcl.Remove_Co) end;
end


function dcl.DimensionItemUpdated(handler,item)
	if type(dcl.Update_Co) == 'thread' then
		coroutine.resume(dcl.Update_Co);
	end
end


function dcl.LoadEnd(handler,identifier)
	if identifier == "DimensionSnapshot" then
		if DimSnap_Settings ~= nil then
			DimSnap_Settings = dcl.MergeTables(dcl.Defaults,DimSnap_Settings);
		else
			DimSnap_Settings = dcl.Defaults;
			print(dcl.GetString(3));
		end
		dcl.DrawWindows();
		dcl.wMain:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.MainWin.X, DimSnap_Settings.MainWin.Y);
		dcl.wMain:SetVisible(DimSnap_Settings.MainWin.Visible);
		dcl.txtRadius:SetText(tostring(DimSnap_Settings.Radius));
		print(dcl.GetString(4));
	end
end


function dcl.SaveBegin()
	DimSnap_Settings.MainWin.Visible = dcl.wMain:GetVisible();
	if tonumber(dcl.txtRadius:GetText()) then DimSnap_Settings.Radius = tonumber(dcl.txtRadius:GetText()) end;
	dcl.Restore_Co = nil;
	dcl.Remove_Co = nil;
	dcl.Update_Co = nil;
	dcl.Print_Co = nil;
end


function dcl.EventUpdates()
	if type(dcl.Avail_Co) == 'thread' and coroutine.status(dcl.Avail_Co) == "suspended" then
		coroutine.resume(dcl.Avail_Co);
	end

	if type(dcl.Update_Co) == 'thread' and coroutine.status(dcl.Update_Co) == "suspended" then
		coroutine.resume(dcl.Update_Co);
	end

	if type(dcl.Print_Co) == 'thread' and coroutine.status(dcl.Print_Co) == "suspended" then
		coroutine.resume(dcl.Print_Co);
	end

	if type(dcl.Export_Co) == 'thread' and coroutine.status(dcl.Export_Co) == "suspended" then
		coroutine.resume(dcl.Export_Co);
	end
end


function dcl.RegEvents()
	Command.Event.Attach(Event.Unit.Availability.Full, dcl.PlayerLoaded, 'dcl.PlayerLoaded');
	Command.Event.Attach(Event.Unit.Detail.Zone, dcl.LocationChanged, 'dcl.LocationChanged');
	Command.Event.Attach(Event.Unit.Detail.Coord, dcl.CoordsUpdate, 'dcl.CoordsUpdate');
	Command.Event.Attach(Event.Addon.Load.End, dcl.LoadEnd, 'dcl.LoadEnd');
	Command.Event.Attach(Event.Dimension.Layout.Add, dcl.DimensionItemAdded, 'dcl.DimensionItemAdded');
	Command.Event.Attach(Event.Dimension.Layout.Remove, dcl.DimensionItemRemoved, 'dcl.DimensionItemRemoved');
	Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, dcl.SaveBegin, 'dcl.SaveBegin')
	Command.Event.Attach(Event.Dimension.Layout.Update, dcl.DimensionItemUpdated, 'dcl.DimensionItemUpdated')
	Command.Event.Attach(Event.System.Update.Begin, dcl.EventUpdates, 'dcl.EventUpdates');
end
