
function dcl.DrawExportWin()

	dcl.wExport = UI.CreateFrame("RiftWindow", "ExportWindow", dcl.Context);
	dcl.wExport:SetTitle(dcl.GetString(47));
	dcl.wExport:SetHeight(400);
	dcl.wExport:SetWidth(500);
	dcl.wExport:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.ExportWin.X, DimSnap_Settings.ExportWin.Y);
	dcl.wExport.dragActive = false;
	dcl.wExport:SetVisible(false);

	local wExportDrag = UI.CreateFrame("Frame", "export drag frame", dcl.wExport)
	wExportDrag:SetAllPoints();

	local closeButton = UI.CreateFrame("RiftButton", "CloseButton", dcl.wExport)
	closeButton:SetSkin("close");
	closeButton:SetPoint("TOPRIGHT", dcl.wExport, "TOPRIGHT", 0, 12);
	closeButton:SetLayer(100);

	local lblExportHelp = dcl.NewLabel("lblExportHelp",dcl.wExport,dcl.wExport:GetWidth()-60,38,30,70,dcl.GetString(29));
	lblExportHelp:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));
	lblExportHelp:SetWordwrap(true);
	lblExportHelp:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));

	local cTextOverlay = UI.CreateFrame("Frame", "cExpTextOverlay", dcl.wExport);
	cTextOverlay:SetWidth(dcl.wExport:GetWidth()-60);
	cTextOverlay:SetHeight(dcl.wExport:GetHeight()-175);
	cTextOverlay:SetPoint("TOPLEFT",dcl.wExport,"TOPLEFT",30,116);
	cTextOverlay:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));

	dcl.txtExport = UI.CreateFrame("SimpleTextArea", "txtExport", dcl.wExport);
	dcl.txtExport:SetPoint("TOPLEFT",dcl.wExport,"TOPLEFT",30,116);
	dcl.txtExport:SetWidth(dcl.wExport:GetWidth()-60);
	dcl.txtExport:SetHeight(dcl.wExport:GetHeight()-175);
	dcl.txtExport:SetLayer(100);

	local btnSelectAll = UI.CreateFrame("RiftButton", "btnSelectAll", dcl.wExport);
	btnSelectAll:SetPoint("TOPLEFT",dcl.wExport,"TOPLEFT",(dcl.wExport:GetWidth()/2)-(btnSelectAll:GetWidth()/2),dcl.wExport:GetHeight()-55);
	btnSelectAll:SetText(dcl.GetString(30));
	btnSelectAll:SetLayer(100);

	btnSelectAll.Event.LeftPress = function ()
		local sLen = string.len(dcl.txtExport:GetText());
		if sLen>0 then
			dcl.txtExport:SetKeyFocus(true);
			dcl.txtExport:SetSelection(0,sLen);
		end
	end


	-- Window Events --
	function closeButton.Event:LeftPress()
		dcl.wExport:SetVisible(false);
	end

	function wExportDrag.Event:LeftDown()
	  dcl.wExport.dragActive = true;
		local mouseStatus = Inspect.Mouse();
		dcl.clickOffset["x"] = mouseStatus.x - DimSnap_Settings.ExportWin.X;
		dcl.clickOffset["y"] = mouseStatus.y - DimSnap_Settings.ExportWin.Y;
	end

	function wExportDrag.Event:LeftUp()
		dcl.wExport.dragActive = false;
	end

	function wExportDrag.Event:LeftUpoutside()
		dcl.wExport.dragActive = false;
	end

	function wExportDrag.Event:MouseMove(x,y)
		if dcl.wExport.dragActive == true then
			DimSnap_Settings.ExportWin.X = x - dcl.clickOffset["x"];
			DimSnap_Settings.ExportWin.Y = y - dcl.clickOffset["y"];
			dcl.wExport:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.ExportWin.X, DimSnap_Settings.ExportWin.Y);
		end
	end

end


function dcl.PrepareExport()
	if dcl.txtDimName:GetText() == "" then print(dcl.GetString(65)) dcl.txtDimName:SetKeyFocus(true) return end;
	if dcl.wExport == nil then dcl.DrawExportWin() end;
	print(tagText(dcl.GetString(71),"Cyan"));
	dcl.btnExport:SetEnabled(false);
	dcl.GetExportText();
end


function dcl.GetExportText()
	local sOutput = "DimensionExport={\n[\"SetName\"]=\""..dcl.txtDimName:GetText().."\";\n[\"Items\"]={\n";
	local itemIndex = 1;
	dcl.Export_Co = coroutine.create( function ()
		local internalCounter = 0;
		local maxBeforeReset = 10;
		for k,v in pairs (dcl.Snapshot) do
			sOutput = sOutput.."["..itemIndex.."]={";
			sOutput = sOutput.."[\"name\"]=\""..v.name.."\";";
			sOutput = sOutput.."[\"type\"]=\""..v.type.."\";";
			sOutput = sOutput.."[\"coordX\"]="..v.coordX..";";
			sOutput = sOutput.."[\"coordY\"]="..v.coordY..";";
			sOutput = sOutput.."[\"coordZ\"]="..v.coordZ..";";
			sOutput = sOutput.."[\"roll\"]="..v.roll..";";
			sOutput = sOutput.."[\"pitch\"]="..v.pitch..";";
			sOutput = sOutput.."[\"yaw\"]="..v.yaw..";";
			sOutput = sOutput.."[\"scale\"]="..v.scale..";";
			sOutput = sOutput.."};\n";
			itemIndex = itemIndex + 1;
			internalCounter = internalCounter + 1;
			if internalCounter >= maxBeforeReset then
				internalCounter = 0;
				coroutine.yield();
			end
		end
		sOutput = sOutput .. "};};";
		dcl.txtExport:SetText(sOutput);
		dcl.wExport:SetVisible(true);
		dcl.btnExport:SetEnabled(true);
	end);
	coroutine.resume(dcl.Export_Co);
end


