
function dcl.DrawImportWin()

	dcl.wImport = UI.CreateFrame("RiftWindow", "ImportWindow", dcl.Context);
	dcl.wImport:SetTitle(dcl.GetString(46));
	dcl.wImport:SetHeight(400);
	dcl.wImport:SetWidth(500);
	dcl.wImport:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.ImportWin.X, DimSnap_Settings.ImportWin.Y);
	dcl.wImport.dragActive = false;

	local wImportDrag = UI.CreateFrame("Frame", "Import drag frame", dcl.wImport)
	wImportDrag:SetAllPoints();

	local closeButton = UI.CreateFrame("RiftButton", "CloseButton", dcl.wImport)
	closeButton:SetSkin("close");
	closeButton:SetPoint("TOPRIGHT", dcl.wImport, "TOPRIGHT", 0, 12);
	closeButton:SetLayer(100);

	local lblImportHelp = dcl.NewLabel("lblImportHelp",dcl.wImport,dcl.wImport:GetWidth()-60,38,30,70,dcl.GetString(48));
	lblImportHelp:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));
	lblImportHelp:SetWordwrap(true);
	lblImportHelp:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));

	local cTextOverlay = UI.CreateFrame("Frame", "cImpTextOverlay", dcl.wImport);
	cTextOverlay:SetWidth(dcl.wImport:GetWidth()-60);
	cTextOverlay:SetHeight(dcl.wImport:GetHeight()-175);
	cTextOverlay:SetPoint("TOPLEFT",dcl.wImport,"TOPLEFT",30,116);
	cTextOverlay:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));

	dcl.txtImport = UI.CreateFrame("SimpleTextArea", "txtImport", dcl.wImport);
	dcl.txtImport:SetPoint("TOPLEFT",dcl.wImport,"TOPLEFT",30,116);
	dcl.txtImport:SetWidth(dcl.wImport:GetWidth()-60);
	dcl.txtImport:SetHeight(dcl.wImport:GetHeight()-175);
	dcl.txtImport:SetLayer(100);

	local btnImport = UI.CreateFrame("RiftButton", "btnImport", dcl.wImport);
	btnImport:SetPoint("TOPLEFT",dcl.wImport,"TOPLEFT",(dcl.wImport:GetWidth()/2)-(btnImport:GetWidth()/2),dcl.wImport:GetHeight()-55);
	btnImport:SetText(dcl.GetString(45));
	btnImport:SetLayer(100);

	btnImport.Event.LeftPress = function ()
		local sLen = string.len(dcl.txtImport:GetText());
		if sLen>0 then
			dcl.GetImportText();
		else
			print(tagText(dcl.GetString(49),"Red"));
		end
	end


	-- Window Events --
	function closeButton.Event:LeftPress()
		dcl.wImport:SetVisible(false);
	end

	function wImportDrag.Event:LeftDown()
	  dcl.wImport.dragActive = true;
		local mouseStatus = Inspect.Mouse();
		dcl.clickOffset["x"] = mouseStatus.x - DimSnap_Settings.ImportWin.X;
		dcl.clickOffset["y"] = mouseStatus.y - DimSnap_Settings.ImportWin.Y;
	end

	function wImportDrag.Event:LeftUp()
		dcl.wImport.dragActive = false;
	end

	function wImportDrag.Event:LeftUpoutside()
		dcl.wImport.dragActive = false;
	end

	function wImportDrag.Event:MouseMove(x,y)
		if dcl.wImport.dragActive == true then
			DimSnap_Settings.ImportWin.X = x - dcl.clickOffset["x"];
			DimSnap_Settings.ImportWin.Y = y - dcl.clickOffset["y"];
			dcl.wImport:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.ImportWin.X, DimSnap_Settings.ImportWin.Y);
		end
	end

end


function dcl.PrepareImport()
	if dcl.wImport == nil then dcl.DrawImportWin() end;
	dcl.txtImport:SetText("");
	dcl.wImport:SetVisible(true);
end


function dcl.GetImportText()

	if DimSnap_Snapshots == nil then DimSnap_Snapshots = {} end;

	local importText = dcl.txtImport:GetText();

	if string.find(importText,"DimensionExport") == nil or string.find(importText,"%[\"SetName\"%]") == nil or string.find(importText,"%[\"Items\"%]={") == nil or string.find(importText,"%}") == nil then
		print(tagText(dcl.GetString(52),"Red"));
		return;
	end

	local getSet = assert(loadstring(string.gsub(dcl.txtImport:GetText(),"\n","")));
	getSet();

	if type(DimensionExport) == 'table' and type(DimensionExport.Items) == 'table' and DimensionExport.SetName ~= nil and dcl.GetTableSize(DimensionExport.Items)>0 then
		table.insert(DimSnap_Snapshots,DimensionExport);
		print(dcl.GetString(50)..DimensionExport.SetName);
		print(dcl.GetString(20)..dcl.GetTableSize(DimensionExport.Items));
		dcl.wImport:SetVisible(false);
	else
		print(tagText(dcl.GetString(53),"Red"));
	end

	dcl.RefreshListSnapshots();

end


