
function dcl.DrawMainWin()

	dcl.wMain = UI.CreateFrame("RiftWindow", "MainWindow", dcl.Context);
	dcl.wMain:SetTitle("");
	dcl.wMain:SetHeight(380);
	dcl.wMain:SetWidth(610);
	dcl.wMain:SetPoint("TOPLEFT",UIParent,"TOPLEFT");
	dcl.wMain:SetVisible(false);
	dcl.wMain.dragActive = false;

	local lblTitle = UI.CreateFrame("Text", "TitleLabel", dcl.wMain);
	lblTitle:SetPoint("TOPCENTER", dcl.wMain, "TOPCENTER",0,12);
	lblTitle:SetFontColor(dcl.ConvertHexColor("#132020"));
	lblTitle:SetFontSize(18);
	lblTitle:SetEffectGlow({["colorR"]=1;["colorG"]=1;["colorB"]=1;["offsetX"]=2;["offsetY"]=2;})
	lblTitle:SetText("Dimension Snapshot");

	local wMainDrag = UI.CreateFrame("Frame", "drag frame", dcl.wMain)
	wMainDrag:SetAllPoints();

	local closeButton = UI.CreateFrame("RiftButton", "CloseButton", dcl.wMain)
	closeButton:SetSkin("close");
	closeButton:SetPoint("TOPRIGHT", dcl.wMain, "TOPRIGHT", 0, 12);
	closeButton:SetLayer(100);


	-- Dim Name / Save --------------------------------------------------------------------------------------------

	local lblDimName = dcl.NewLabel("lblDimName",dcl.wMain,45,nil,35,58,dcl.GetString(61));
	--lblDimName:SetBackgroundColor(dcl.ConvertHexColor("#000000"));

	dcl.txtDimName = UI.CreateFrame("RiftTextfield", "txtDimName", dcl.wMain);
	dcl.txtDimName:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",82,58);
	dcl.txtDimName:SetWidth(220);
	dcl.txtDimName:SetLayer(100);
	dcl.txtDimName:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.8));

	dcl.btnSave = UI.CreateFrame("RiftButton", "btnSave", dcl.wMain);
	dcl.btnSave:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",(dcl.wMain:GetWidth()-20-(dcl.btnSave:GetWidth()*2)),50);
	dcl.btnSave:SetText(dcl.GetString(8));
	dcl.btnSave:SetLayer(100);

	dcl.btnSave.Event.LeftPress = function ()
		dcl.SaveSnapshot();
	end

	dcl.btnExport = UI.CreateFrame("RiftButton", "btnExport", dcl.wMain);
	dcl.btnExport:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",(dcl.wMain:GetWidth()-30-dcl.btnExport:GetWidth()),50);
	dcl.btnExport:SetText(dcl.GetString(7));
	dcl.btnExport:SetLayer(100);

	dcl.btnExport.Event.LeftPress = function ()
		dcl.PrepareExport();
	end

	dcl.cBackOverlay = UI.CreateFrame("Frame", "cBackOverlay", dcl.wMain);
	dcl.cBackOverlay:SetWidth(540);
	dcl.cBackOverlay:SetHeight(180);
	dcl.cBackOverlay:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",35,170);
	dcl.cBackOverlay:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));


	-- Coords Container ------------------------------------------------------------------------------------------

	dcl.cCoordContainer = UI.CreateFrame("Frame", "cCoordContainer", dcl.wMain);
	dcl.cCoordContainer:SetWidth(540);
	dcl.cCoordContainer:SetHeight(72);
	dcl.cCoordContainer:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",35,90);
	dcl.cCoordContainer:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.65));

	-- Player Coords Container -----------------------------------------------------------------------------------

	dcl.cPlayerCoords = UI.CreateFrame("Frame", "cPlayerCoords", dcl.cCoordContainer);
	dcl.cPlayerCoords:SetWidth(100);
	dcl.cPlayerCoords:SetHeight(72);
	dcl.cPlayerCoords:SetPoint("TOPLEFT",dcl.cCoordContainer,"TOPLEFT",0,0);

	dcl.lblPlayerCoords = dcl.NewLabel("lblPlayerCoords",dcl.cPlayerCoords,100,nil,0,0,dcl.GetString(5));
	dcl.lblPlayerCoords:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsX = dcl.NewLabel("lblCoordsX",dcl.cPlayerCoords,100,nil,0,18,"X: -");
	dcl.lblCoordsX:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsY = dcl.NewLabel("lblCoordsY",dcl.cPlayerCoords,100,nil,0,36,"Y: -");
	dcl.lblCoordsY:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsZ = dcl.NewLabel("lblCoordsZ",dcl.cPlayerCoords,100,nil,0,54,"Z: -");
	dcl.lblCoordsZ:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	-- Boundary Min Coords Container -----------------------------------------------------------------------------

	dcl.cBoundMinCoords = UI.CreateFrame("Frame", "cBoundMinCoords", dcl.cCoordContainer);
	dcl.cBoundMinCoords:SetWidth(100);
	dcl.cBoundMinCoords:SetHeight(72);
	dcl.cBoundMinCoords:SetPoint("TOPLEFT",dcl.cCoordContainer,"TOPLEFT",110,0);

	dcl.lblBoundMin = dcl.NewLabel("lblBoundMin",dcl.cBoundMinCoords,100,nil,0,0,dcl.GetString(9));
	dcl.lblBoundMin:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMinX = dcl.NewLabel("lblCoordsMinX",dcl.cBoundMinCoords,100,nil,0,18,"X: -");
	dcl.lblCoordsMinX:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMinY = dcl.NewLabel("lblCoordsMinY",dcl.cBoundMinCoords,100,nil,0,36,"Y: -");
	dcl.lblCoordsMinY:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMinZ = dcl.NewLabel("lblCoordsMinZ",dcl.cBoundMinCoords,100,nil,0,54,"Z: -");
	dcl.lblCoordsMinZ:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	-- Boundary Max Coords Container -----------------------------------------------------------------------------

	dcl.cBoundMaxCoords = UI.CreateFrame("Frame", "cBoundMaxCoords", dcl.cCoordContainer);
	dcl.cBoundMaxCoords:SetWidth(100);
	dcl.cBoundMaxCoords:SetHeight(72);
	dcl.cBoundMaxCoords:SetPoint("TOPLEFT",dcl.cCoordContainer,"TOPLEFT",220,0);

	dcl.lblBoundMax = dcl.NewLabel("lblBoundMax",dcl.cBoundMaxCoords,100,nil,0,0,dcl.GetString(10));
	dcl.lblBoundMax:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMaxX = dcl.NewLabel("lblCoordsMaxX",dcl.cBoundMaxCoords,100,nil,0,18,"X: -");
	dcl.lblCoordsMaxX:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMaxY = dcl.NewLabel("lblCoordsMaxY",dcl.cBoundMaxCoords,100,nil,0,36,"Y: -");
	dcl.lblCoordsMaxY:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsMaxZ = dcl.NewLabel("lblCoordsMaxZ",dcl.cBoundMaxCoords,100,nil,0,54,"Z: -");
	dcl.lblCoordsMaxZ:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	-- Boundary Centre Coords Container -----------------------------------------------------------------------------

	dcl.cBoundCentreCoords = UI.CreateFrame("Frame", "cBoundCentreCoords", dcl.cCoordContainer);
	dcl.cBoundCentreCoords:SetWidth(100);
	dcl.cBoundCentreCoords:SetHeight(72);
	dcl.cBoundCentreCoords:SetPoint("TOPLEFT",dcl.cCoordContainer,"TOPLEFT",330,0);

	dcl.lblBoundCentre = dcl.NewLabel("lblBoundCentre",dcl.cBoundCentreCoords,100,nil,0,0,dcl.GetString(11));
	dcl.lblBoundCentre:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsCentreX = dcl.NewLabel("lblCoordsCentreX",dcl.cBoundCentreCoords,100,nil,0,18,"X: -");
	dcl.lblCoordsCentreX:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsCentreY = dcl.NewLabel("lblCoordsCentreY",dcl.cBoundCentreCoords,100,nil,0,36,"Y: -");
	dcl.lblCoordsCentreY:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblCoordsCentreZ = dcl.NewLabel("lblCoordsCentreZ",dcl.cBoundCentreCoords,100,nil,0,54,"Z: -");
	dcl.lblCoordsCentreZ:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	-- Boundary Dimensions Container -----------------------------------------------------------------------------

	dcl.cBoundDims = UI.CreateFrame("Frame", "cBoundDims", dcl.cCoordContainer);
	dcl.cBoundDims:SetWidth(100);
	dcl.cBoundDims:SetHeight(72);
	dcl.cBoundDims:SetPoint("TOPLEFT",dcl.cCoordContainer,"TOPLEFT",440,0);

	dcl.lblBoundDims = dcl.NewLabel("lblBoundDims",dcl.cBoundDims,100,nil,0,0,dcl.GetString(12));
	dcl.lblBoundDims:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblBoundDimsX = dcl.NewLabel("lblBoundDimsX",dcl.cBoundDims,100,nil,0,18,"X: -");
	dcl.lblBoundDimsX:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblBoundDimsY = dcl.NewLabel("lblBoundDimsY",dcl.cBoundDims,100,nil,0,36,"Y: -");
	dcl.lblBoundDimsY:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	dcl.lblBoundDimsZ = dcl.NewLabel("lblBoundDimsZ",dcl.cBoundDims,100,nil,0,54,"Z: -");
	dcl.lblBoundDimsZ:SetFontColor(dcl.ConvertHexColor("#bbe0ef"));

	-- Snapshot Buttons Container ---------------------------------------------------------------------------------

	dcl.cSnapBtnCont = UI.CreateFrame("Frame", "cSnapBtnCont", dcl.wMain);
	dcl.cSnapBtnCont:SetWidth(180);
	dcl.cSnapBtnCont:SetHeight(150);
	dcl.cSnapBtnCont:SetPoint("TOPLEFT",dcl.wMain,"TOPLEFT",40,170);
	dcl.cSnapBtnCont:SetLayer(100);
	--dcl.cSnapBtnCont:SetBackgroundColor(dcl.ConvertHexColor("#000000"));

	dcl.btnSnapshot = UI.CreateFrame("RiftButton", "btnSnapshot", dcl.cSnapBtnCont);
	dcl.btnSnapshot:SetPoint("TOPLEFT",dcl.cSnapBtnCont,"TOPLEFT",0,0);
	dcl.btnSnapshot:SetText(dcl.GetString(38));
	dcl.btnSnapshot:SetLayer(100);

	dcl.btnSnapshot.Event.LeftPress = function ()
		dcl.NewSnapShot();
	end

	dcl.btnSnapAdd = UI.CreateFrame("RiftButton", "btnSnapAdd", dcl.cSnapBtnCont);
	dcl.btnSnapAdd:SetPoint("TOPLEFT",dcl.cSnapBtnCont,"TOPLEFT",0,30);
	dcl.btnSnapAdd:SetText(dcl.GetString(41));
	dcl.btnSnapAdd:SetLayer(100);
	dcl.btnSnapAdd:SetEnabled(false);

	dcl.btnSnapAdd.Event.LeftPress = function ()
		dcl.AddToSnapshot();
	end

	dcl.btnPrint = UI.CreateFrame("RiftButton", "btnPrint", dcl.cSnapBtnCont);
	dcl.btnPrint:SetPoint("TOPLEFT",dcl.cSnapBtnCont,"TOPLEFT",0,60);
	dcl.btnPrint:SetText(dcl.GetString(17));
	dcl.btnPrint:SetLayer(100);

	dcl.btnPrint.Event.LeftPress = function ()
		dcl.PrintDetails();
	end

	dcl.btnCrate = UI.CreateFrame("RiftButton", "btnCrate", dcl.cSnapBtnCont);
	dcl.btnCrate:SetPoint("TOPLEFT",dcl.cSnapBtnCont,"TOPLEFT",0,90);
	dcl.btnCrate:SetText(dcl.GetString(13));
	dcl.btnCrate:SetLayer(100);

	dcl.btnCrate.Event.LeftPress = function ()
		dcl.BeginPackChecks();
	end

	dcl.btnRestore = UI.CreateFrame("RiftButton", "btnRestore", dcl.cSnapBtnCont);
	dcl.btnRestore:SetPoint("TOPLEFT",dcl.cSnapBtnCont,"TOPLEFT",0,120);
	dcl.btnRestore:SetText(dcl.GetString(14));
	dcl.btnRestore:SetLayer(100);

	dcl.btnRestore.Event.LeftPress = function ()
		dcl.PrepareForRestore();
	end

	-- Load container ----------------------------------------------------------------------------------------------------

	dcl.cLoadContainer = UI.CreateFrame("Frame", "cLoadContainer", dcl.wMain);
	dcl.cLoadContainer:SetWidth(300);
	dcl.cLoadContainer:SetHeight(150);
	dcl.cLoadContainer:SetPoint("TOPRIGHT",dcl.wMain,"TOPRIGHT",-45,175);
	dcl.cLoadContainer:SetLayer(100);
	--dcl.cLoadContainer:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.5));

	local lblRadius = dcl.NewLabel("lblRadius",dcl.cLoadContainer,140,nil,dcl.cLoadContainer:GetWidth()-182,0,dcl.GetString(62));

	dcl.txtRadius = UI.CreateFrame("RiftTextfield", "txtRadius", dcl.cLoadContainer);
	dcl.txtRadius:SetPoint("TOPRIGHT",dcl.cLoadContainer,"TOPRIGHT",0,0);
	dcl.txtRadius:SetWidth(40);
	dcl.txtRadius:SetLayer(100);
	dcl.txtRadius:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.8));

	dcl.txtRadius.Event.KeyDown = function (handle,button)
		if button == "Tab" then dcl.txtLoadX:SetKeyFocus(true) end;
	end

	local lblLoadPoint = dcl.NewLabel("lblLoadPoint",dcl.cLoadContainer,150,nil,0,20,dcl.GetString(63));

	local lblX = dcl.NewLabel("lblX",dcl.cLoadContainer,20,nil,0,40,"X:");

	dcl.txtLoadX = UI.CreateFrame("RiftTextfield", "txtLoadX", dcl.cLoadContainer);
	dcl.txtLoadX:SetPoint("TOPLEFT",dcl.cLoadContainer,"TOPLEFT",20,40);
	dcl.txtLoadX:SetWidth(70);
	dcl.txtLoadX:SetLayer(100);
	dcl.txtLoadX:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.8));

	dcl.txtLoadX.Event.KeyDown = function (handle,button)
		if button == "Tab" then dcl.txtLoadY:SetKeyFocus(true) end;
	end

	local lblY = dcl.NewLabel("lblY",dcl.cLoadContainer,20,nil,105,40,"Y:");

	dcl.txtLoadY = UI.CreateFrame("RiftTextfield", "txtLoadY", dcl.cLoadContainer);
	dcl.txtLoadY:SetPoint("TOPLEFT",dcl.cLoadContainer,"TOPLEFT",125,40);
	dcl.txtLoadY:SetWidth(70);
	dcl.txtLoadY:SetLayer(100);
	dcl.txtLoadY:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.8));

	dcl.txtLoadY.Event.KeyDown = function (handle,button)
		if button == "Tab" then dcl.txtLoadZ:SetKeyFocus(true) end;
	end

	local lblZ = dcl.NewLabel("lblZ",dcl.cLoadContainer,20,nil,210,40,"Z:");

	dcl.txtLoadZ = UI.CreateFrame("RiftTextfield", "txtLoadZ", dcl.cLoadContainer);
	dcl.txtLoadZ:SetPoint("TOPLEFT",dcl.cLoadContainer,"TOPLEFT",230,40);
	dcl.txtLoadZ:SetWidth(70);
	dcl.txtLoadZ:SetLayer(100);
	dcl.txtLoadZ:SetBackgroundColor(dcl.ConvertHexColor("#000000",0.8));

	dcl.txtLoadZ.Event.KeyDown = function (handle,button)
		if button == "Tab" then dcl.txtRadius:SetKeyFocus(true) end;
	end

	dcl.btnDelete = UI.CreateFrame("RiftButton", "dcl.btnDelete", dcl.cLoadContainer)
	dcl.btnDelete:SetSkin("close");
	dcl.btnDelete:SetPoint("TOPLEFT", dcl.cLoadContainer, "TOPLEFT", 0, 72);
	dcl.btnDelete:SetLayer(100);
	dcl.btnDelete:SetEnabled(false);

	dcl.btnDelete.Event.LeftPress = function ()
		if dcl.ddLoad:GetSelectedIndex() ~= nil then
			dcl.DeleteSnapshot(dcl.ddLoad:GetSelectedIndex());
		end
	end

	dcl.ddLoad = UI.CreateFrame("SimpleSelect","ddLoad", dcl.cLoadContainer);
	dcl.ddLoad:SetPoint("TOPRIGHT",dcl.cLoadContainer,"TOPRIGHT",0,80);
	dcl.ddLoad:SetWidth(260);
	dcl.ddLoad:SetLayer(100);

	dcl.ddLoad.Event.ItemSelect = function ()
		dcl.btnDelete:SetEnabled(true);
	end

	dcl.btnLoad = UI.CreateFrame("RiftButton", "btnLoad", dcl.cLoadContainer);
	dcl.btnLoad:SetPoint("TOPRIGHT",dcl.cLoadContainer,"TOPRIGHT",-130,105);
	dcl.btnLoad:SetText(dcl.GetString(51));
	dcl.btnLoad:SetLayer(100);

	dcl.btnLoad.Event.LeftPress = function ()
		dcl.PrepareForLoad();
	end

	dcl.btnMats = UI.CreateFrame("RiftButton", "btnMats", dcl.cLoadContainer);
	dcl.btnMats:SetPoint("TOPRIGHT",dcl.cLoadContainer,"TOPRIGHT",0,105);
	dcl.btnMats:SetText(dcl.GetString(17));
	dcl.btnMats:SetLayer(100);

	dcl.btnMats.Event.LeftPress = function ()
		dcl.PrintMats();
	end

	dcl.btnImport = UI.CreateFrame("RiftButton", "btnImport", dcl.cLoadContainer);
	dcl.btnImport:SetPoint("TOPRIGHT",dcl.cLoadContainer,"TOPRIGHT",0,135);
	dcl.btnImport:SetText(dcl.GetString(45));
	dcl.btnImport:SetLayer(100);

	dcl.btnImport.Event.LeftPress = function ()
		dcl.PrepareImport();
	end


	-- Window Events --

	function closeButton.Event:LeftPress()
		dcl.wMain:SetVisible(false);
	end

	function wMainDrag.Event:LeftDown()
	  dcl.wMain.dragActive = true;
		local mouseStatus = Inspect.Mouse();
		dcl.clickOffset["x"] = mouseStatus.x - DimSnap_Settings.MainWin.X;
		dcl.clickOffset["y"] = mouseStatus.y - DimSnap_Settings.MainWin.Y;
	end

	function wMainDrag.Event:LeftUp()
		dcl.wMain.dragActive = false;
	end

	function wMainDrag.Event:LeftUpoutside()
		dcl.wMain.dragActive = false;
	end

	function wMainDrag.Event:MouseMove(x,y)
		if dcl.wMain.dragActive == true then
			DimSnap_Settings.MainWin.X = x - dcl.clickOffset["x"];
			DimSnap_Settings.MainWin.Y = y - dcl.clickOffset["y"];
			dcl.wMain:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DimSnap_Settings.MainWin.X, DimSnap_Settings.MainWin.Y);
		end
	end

end


-- PACK ---------------------------------------------------------------------------------------------------------------------------

function dcl.BeginPackChecks()
	if dcl.InDimension() == false then return end;
	if dcl.GetTableSize(dcl.Snapshot) == 0 then return end;
	local perimeter = dcl.StringToNumber(dcl.txtRadius:GetText(),150,dcl.GetString(68));
	if perimeter == nil then return end;
	-- First Check
	dcl.PackItems_CheckOne(perimeter);
end


function dcl.PackItems_CheckOne(perimeter)
	-- Confirm packing of items
	local confirmMsg = MessageBox(dcl.GetString(15),MBOKCANCEL);
	confirmMsg.ButtonClick = function (sender,args)
		if args.Button == MBOK then dcl.PackItems_CheckTwo(perimeter) end;
	end
end


function dcl.PackItems_CheckTwo(perimeter)
	-- Get inventory space needed
	local listTypes = dcl.GetDimensionItemList();		-- item.type = quantity
	local slotsNeeded = 0;
	for k,v in pairs (listTypes) do
		slotsNeeded = slotsNeeded + dcl.GetSlotsNeeded(k,v);
	end
	dcl.PackItems_CheckThree(slotsNeeded,perimeter);
end


function dcl.PackItems_CheckThree(slotsNeeded,perimeter)
	-- Check inventory free space
	local freeSlots,invCap = dcl.GetInvFreeSpace();
	if slotsNeeded > freeSlots then
		local warning = "";
		if slotsNeeded > invCap then
			warning = dcl.GetString(25).." "..dcl.GetString(26);
		else
			warning = dcl.GetString(19).." "..dcl.GetString(26);
		end
		local msg = MessageBox(warning,MBOKCANCEL);
		msg.ButtonClick = function (sender,args)
			if args.Button == MBOK then dcl.PrepareForPack(perimeter) end;
		end
		print(dcl.GetString(21)..slotsNeeded); -- Bag Slots Needed:
		print(dcl.GetString(22)..freeSlots); -- Bag Slots Available:
		print(dcl.GetString(24)..invCap); -- Inventory Capacity
	else
		dcl.PrepareForPack(perimeter);
	end
end


function dcl.PrepareForPack(perimeter)
	dcl.Restore_Co = nil;
	print(tagText(dcl.GetString(32),"Cyan"));
	dcl.PackItems(perimeter);
end


function dcl.PackItems(perimeter)
	if dcl.InDimension() == false then return end;
	local skipped = 0;
	local playerInfo = Inspect.Unit.Detail("player");
	dcl.Remove_Co = coroutine.create( function ()
		for k,v in pairs(dcl.Snapshot) do
			local item = Inspect.Dimension.Layout.Detail(v.id);
			if item ~= nil and item.selected == nil and dcl.InPerimeter(item.coordX,item.coordY,item.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,perimeter) then
				Command.Dimension.Layout.Pickup(v.id);
				coroutine.yield();
			else
				skipped = skipped + 1;
			end
		end
		print(tagText(dcl.GetString(31),"Cyan"));
		if skipped > 0 then
			print(dcl.GetString(23)..skipped);
		end
	end);
	coroutine.resume(dcl.Remove_Co);
end


-- RESTORE --------------------------------------------------------------------------------------------------------------------

function dcl.PrepareForRestore()
	if dcl.InDimension() == false or type(dcl.Snapshot) ~= 'table' then return end;
	if dcl.GetTableSize(dcl.Snapshot) == 0 then print(tagText(dcl.GetString(37),"Red")) return end;
	local perimeter = dcl.StringToNumber(dcl.txtRadius:GetText(),150,dcl.GetString(68));
	if perimeter == nil then return end;
	local playerInfo = Inspect.Unit.Detail("player");
	dcl.btnSnapAdd:SetEnabled(false);
	print(tagText(dcl.GetString(34),"Cyan"));
	dcl.RestoreDim(perimeter,playerInfo);
end


function dcl.RestoreDim(perimeter,playerInfo)	-- First step removes items not part of the snapshot
	dcl.Restore_Co = nil;

	local itemList = Inspect.Dimension.Layout.List();
	local tRemove = {};

	-- Prep remove table
	for k,v in pairs(itemList) do
		if v==false then
			local item = Inspect.Dimension.Layout.Detail(k);
			if item ~= nil and item.selected == nil and dcl.InPerimeter(item.coordX,item.coordY,item.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,perimeter) then
				if dcl.GetSnapshotID(item) == nil then table.insert(tRemove,item) end;
			end
		end
	end

	-- Prep item types
	local listTypes = dcl.GetDimensionItemList(tRemove);

	-- Get inventory space needed
	local slotsNeeded = 0;
	for k,v in pairs (listTypes) do
		slotsNeeded = slotsNeeded + dcl.GetSlotsNeeded(k,v);
	end

	-- Check inventory free space
	local freeSlots,invCap = dcl.GetInvFreeSpace();
	if slotsNeeded > freeSlots then
		local warning = "";
		if slotsNeeded > invCap then
			warning = dcl.GetString(25).." "..dcl.GetString(26);
		else
			warning = dcl.GetString(19).." "..dcl.GetString(26);
		end
		local msg = MessageBox(warning,MBOKCANCEL);
		msg.ButtonClick = function (sender,args)
			if args.Button == MBOK then dcl.RestoreRemove(perimeter,tRemove,playerInfo) end;
		end
		print(dcl.GetString(21)..slotsNeeded); -- Bag Slots Needed:
		print(dcl.GetString(22)..freeSlots); -- Bag Slots Available:
		print(dcl.GetString(24)..invCap); -- Inventory Capacity
	else
		dcl.RestoreRemove(perimeter,tRemove,playerInfo);
	end
end


function dcl.RestoreRemove(perimeter,removeList,playerInfo)
	dcl.Remove_Co = coroutine.create( function ()
		for k,v in pairs(removeList) do
			local item = Inspect.Dimension.Layout.Detail(v.id);
			if item ~= nil then
				Command.Dimension.Layout.Pickup(v.id);
				coroutine.yield();
			end
		end
		dcl.RestoreDim2(perimeter,playerInfo);
	end);
	coroutine.resume(dcl.Remove_Co);
end


function dcl.RestoreDim2(perimeter,playerInfo)	-- Second call repositions any items that have moved
	dcl.Remove_Co = nil;
	local itemList = Inspect.Dimension.Layout.List();
	dcl.Update_Co = coroutine.create( function ()
		for k,v in pairs(itemList) do
			if v==false then
				local item = Inspect.Dimension.Layout.Detail(k);
				if item ~= nil and dcl.InPerimeter(item.coordX,item.coordY,item.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,perimeter) then
					if dcl.ItemStatsChanged(item) == true then
						local snapID = dcl.GetSnapshotID(item);
						local properties = dcl.Snapshot[snapID];
						Command.Dimension.Layout.Place(item.id, {["coordX"]=properties.coordX;["coordY"]=properties.coordY;["coordZ"]=properties.coordZ;["pitch"]=properties.pitch;["roll"]=properties.roll;["yaw"]=properties.yaw;["scale"]=properties.scale;});
						coroutine.yield();
					end
				end
			end
		end
		dcl.RestoreDim3(perimeter,playerInfo);
	end);
	coroutine.resume(dcl.Update_Co);
end


function dcl.RestoreDim3(perimeter,playerInfo)	-- Third call replaces any items missing from the snapshot
	Update_Co = nil;
	dcl.Restore_Co = coroutine.create( function ()
		for k,v in pairs(dcl.Snapshot) do
			if dcl.IsInDimension(v) == false and dcl.InPerimeter(v.coordX,v.coordY,v.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,perimeter) then
				dcl.PlaceInvItem(v.type,v)
				coroutine.yield();
			end
		end
		dcl.VerifyRestore();
		end);
	coroutine.resume(dcl.Restore_Co);
end


function dcl.VerifyRestore()
	dcl.Restore_Co = nil;
	print(tagText(dcl.GetString(70),"Cyan"));
end


-----------------------------------------------------------------------------------------------------------------------------------------

function dcl.PrintDetails()
	print(tagText(dcl.GetString(78),"Cyan"));
	dcl.Print_Co = coroutine.create( function ()
		local listTypes = dcl.GetDimensionItemList();		-- item.type = quantity
		local slotsNeeded = 0;
		local playerInv = dcl.GetPlayerInventory();
		local internalCounter = 0;
		local maxBeforeReset = 10;
		for itemType,Qty in pairs (listTypes) do
			local stackCount,stackQty = 0,0;
			local stackSize = Inspect.Item.Detail(itemType).stackMax;
			if playerInv[itemType] ~= nil then
				for k,v in pairs(playerInv[itemType]) do
					stackCount = stackCount + 1;
					stackQty = stackQty + v;
				end
			end
			slotsNeeded = slotsNeeded + (math.ceil((stackQty+Qty)/stackSize)-stackCount);
			internalCounter = internalCounter + 1;
			if internalCounter >= maxBeforeReset then
				internalCounter = 0;
				coroutine.yield();
			end
		end
		dcl.CompletePrint(slotsNeeded);
	end);
	coroutine.resume(dcl.Print_Co);
end


function dcl.CompletePrint(slotsNeeded)
	local invFree, invCap = dcl.GetInvFreeSpace();
	print(tagText(dcl.GetString(40),"Cyan"));
	dcl.PrintDimensionItems();
	print(dcl.GetString(1)..dcl.Zone);
	print(dcl.GetString(20)..dcl.GetTableSize(dcl.Snapshot)); -- Items
	print(tagText(dcl.GetString(75),"Yellow"));
	print(dcl.GetString(21)..slotsNeeded); -- Bag Slots Needed:
	print(dcl.GetString(22)..invFree); -- Bag Slots Available:
	print(dcl.GetString(24)..invCap); -- Inventory Capacity
end


function dcl.PrintMats()
	local selIndex = dcl.ddLoad:GetSelectedIndex();
	if selIndex == nil then print(tagText(dcl.GetString(54),"Red")) return end;
	if type(DimSnap_Snapshots[selIndex])~='table' or DimSnap_Snapshots[selIndex].Items == nil or DimSnap_Snapshots[selIndex].SetName == nil then print(tagText(dcl.GetString(55),"Red")) return end;
	print(tagText(dcl.GetString(79),"Yellow"));
	print(tagText(DimSnap_Snapshots[selIndex].SetName,"Cyan"));
	local itemList = dcl.GetDimensionItemList(DimSnap_Snapshots[selIndex].Items);
	local itemCount = 0;
	for k,v in pairs (itemList) do
		local item = Inspect.Item.Detail(k);
		print(tagText(item.name.." = "..v,"LightSlateGray"));
		itemCount = itemCount + v;
	end
	print(dcl.GetString(20)..itemCount); -- Items
	local setCentre, setMin, setMax = dcl.GetItemscentre(DimSnap_Snapshots[selIndex].Items);
	print(dcl.GetString(12).." X: "..dcl.abs(setMax.X-setMin.X));
	print(dcl.GetString(12).." Y: "..dcl.abs(setMax.Y-setMin.Y));
	print(dcl.GetString(12).." Z: "..dcl.abs(setMax.Z-setMin.Z));
end


function dcl.PlaceInvItem(itemType,properties)

	if (DimSnap_Settings.Load.Bags) then
		local invItems = Inspect.Item.Detail(Inspect.Item.List(Utility.Item.Slot.Inventory()));
		for slot,details in pairs(invItems) do
			if details.type == itemType then
				Command.Dimension.Layout.Place(details.id,{["coordX"]=properties.coordX;["coordY"]=properties.coordY;["coordZ"]=properties.coordZ;["pitch"]=properties.pitch;["roll"]=properties.roll;["yaw"]=properties.yaw;["scale"]=properties.scale;});
				return;
			end
		end
	end

	if (DimSnap_Settings.Load.Bank) then
		local bankItem = Inspect.Item.List(Utility.Item.Slot.Bank())
        for slot, id in pairs(bankItem) do
            if id ~= false then
                local data = Inspect.Item.Detail(id)
                if data.type == itemType then
					if data.stack == 1 then

					else
						Command.Dimension.Layout.Place(id,{["coordX"]=properties.coordX;["coordY"]=properties.coordY;["coordZ"]=properties.coordZ;["pitch"]=properties.pitch;["roll"]=properties.roll;["yaw"]=properties.yaw;["scale"]=properties.scale;});
						return;
					end
				end
            end
        end

		local vaultItem = Inspect.Item.List(Utility.Item.Slot.Vault())
        for slot, id in pairs(vaultItem) do
            if id ~= false then
                local data = Inspect.Item.Detail(id)
                 if data.type == itemType then
					if data.stack == 1 then

					else
						Command.Dimension.Layout.Place(id,{["coordX"]=properties.coordX;["coordY"]=properties.coordY;["coordZ"]=properties.coordZ;["pitch"]=properties.pitch;["roll"]=properties.roll;["yaw"]=properties.yaw;["scale"]=properties.scale;});
						return;
					end
                end
            end
        end
	end

	return false;
end



function dcl.NewSnapShot()
	if dcl.InDimension() == false then dcl.Reset() return end;
	if dcl.GetDimensionSize() == 0 then
		print(tagText(dcl.GetString(27),"Red"));
		return;
	end
	dcl.Snapshot = dcl.GetSnapshot();
	if dcl.GetTableSize(dcl.Snapshot) > 0 then
		print(tagText(dcl.GetString(33),"Cyan"));
		print(dcl.GetString(39)..dcl.GetTableSize(dcl.Snapshot).."/"..dcl.GetDimensionSize());
		dcl.btnSnapAdd:SetEnabled(true);
		dcl.btnPrint:SetEnabled(true);
		dcl.btnCrate:SetEnabled(true);
		dcl.btnSave:SetEnabled(true);
		dcl.btnExport:SetEnabled(true);
		dcl.btnRestore:SetEnabled(true);
	else
		print(tagText(dcl.GetString(69),"Red"));
	end
end


function dcl.AddToSnapshot()
	local oldSnapSize = dcl.GetTableSize(dcl.Snapshot);
	if oldSnapSize == 0 then dcl.NewSnapShot() return end;
	local snap = dcl.GetSnapshot();
	for k,v in ipairs (snap) do
		if dcl.GetSnapshotID(v) == nil then
			table.insert(dcl.Snapshot,v);
		end
	end
	local snapSize = dcl.GetTableSize(dcl.Snapshot);
	if snapSize == oldSnapSize then
		print(dcl.GetString(43))
		return;
	end
	print(tagText(dcl.GetString(42),"Cyan"));
	print(dcl.GetString(44)..(snapSize-oldSnapSize));
	print(dcl.GetString(39)..dcl.GetTableSize(dcl.Snapshot).."/"..dcl.GetDimensionSize());
	dcl.btnSave:SetEnabled(true);
end


function dcl.RefreshListSnapshots()

--[[

SetItems(items, values)
Sets the list of items (table of strings) to be displayed and the optional list of values (table of objects) which are associated
by index with the items. Automatically adjusts the height the dropdown. Clears the current selection.

--]]
	if DimSnap_Snapshots == nil then DimSnap_Snapshots = {} end;

	local setNames = {};
	local setCount = 0;
	for k,v in ipairs(DimSnap_Snapshots) do
		table.insert(setNames,v.SetName.." - "..dcl.GetString(20)..dcl.GetTableSize(v.Items));
		setCount = setCount + 1;
	end
	dcl.ddLoad:SetItems(setNames);
	if setCount > 0 and dcl.InDimension() then
		dcl.btnLoad:SetEnabled(true);
	else
		dcl.btnLoad:SetEnabled(false);
	end
	dcl.btnDelete:SetEnabled(false);
end


function dcl.DeleteSnapshot(index)

	if index==nil or DimSnap_Snapshots[index] == nil then return end;

	local message = dcl.GetString(64);
	message = string.gsub(message,"<var>",DimSnap_Snapshots[index].SetName,1);

	-- Prompt check before continuing.
	local msg = MessageBox(message,MBOKCANCEL);
	msg.ButtonClick = function (sender,args)
		if args.Button == MBOK then
			table.remove(DimSnap_Snapshots,index);
			dcl.RefreshListSnapshots();
		end
	end
end


function dcl.SaveSnapshot()

	if dcl.txtDimName:GetText() == "" then print(dcl.GetString(65)) dcl.txtDimName:SetKeyFocus(true) return end;
	if #dcl.Snapshot == 0 then print(dcl.GetString(66)) return end;

	local saveTable = {};

	saveTable["SetName"] = dcl.txtDimName:GetText();
	saveTable["Items"] = {};

	for k,v in pairs (dcl.Snapshot) do
		table.insert(saveTable.Items, { ["name"]=v.name;["type"]=v.type;["coordX"]=v.coordX;["coordY"]=v.coordY;["coordZ"]=v.coordZ;["roll"]=v.roll;["pitch"]=v.pitch;["yaw"]=v.yaw;["scale"]=v.scale; } );
	end

	table.insert(DimSnap_Snapshots,saveTable);

	dcl.RefreshListSnapshots();
	dcl.btnSave:SetEnabled(false);
	print(tagText(dcl.GetString(67),"Cyan"));
end

-- LOAD --------------------------------------------------------------------------------------------------------------------------

function dcl.PrepareForLoad()
	if dcl.InDimension() == false then return end;
	local selIndex = dcl.ddLoad:GetSelectedIndex();
	if selIndex == nil then print(tagText(dcl.GetString(54),"Red")) return end;
	print(tagText(dcl.GetString(56),"Cyan"));
	local perimeter = dcl.StringToNumber(dcl.txtRadius:GetText(),150,dcl.GetString(68));
	if perimeter == nil then return end;
	local cenX = dcl.StringToNumber(dcl.txtLoadX:GetText(),0,dcl.GetString(72).." (X)");
	if cenX == nil then return end;
	local cenY = dcl.StringToNumber(dcl.txtLoadY:GetText(),0,dcl.GetString(72).." (Y)");
	if cenY == nil then return end;
	local cenZ = dcl.StringToNumber(dcl.txtLoadZ:GetText(),0,dcl.GetString(72).." (Z)");
	if cenZ == nil then return end;
	if type(DimSnap_Snapshots[selIndex])~='table' or DimSnap_Snapshots[selIndex].Items == nil then print(tagText(dcl.GetString(55),"Red")) return end;
	local tSnapShot = dcl.DeepCopy(DimSnap_Snapshots[selIndex].Items);
	dcl.Load_CalcOffset(tSnapShot,{["centreX"]=cenX;["centreY"]=cenY;["centreZ"]=cenZ;["perimeter"]=perimeter;});
end


function dcl.Load_CalcOffset(tLoad,args)
	-- Checks whether offsets are needed, if so reasigns the coords to each item in the table.
	if args.centreX ~= 0 or args.centreY ~= 0 or args.centreZ ~= 0 then
		local setCentre,setMin,SetMax = dcl.GetItemscentre(tLoad);
		for k,v in pairs (tLoad) do
			if args.centreX ~= 0 then v.coordX = args.centreX + (v.coordX - setCentre.X) end;
			if args.centreY ~= 0 then v.coordY = args.centreY + (v.coordY - setMin.Y) end;
			if args.centreZ ~= 0 then v.coordZ = args.centreZ + (v.coordZ - setCentre.Z) end;
		end
	end
	dcl.Load_CheckPerim(tLoad,args);
end


function dcl.Load_CheckPerim(tLoad,args)

	local playerInfo = Inspect.Unit.Detail("player");

	local flagRemove = {}; -- list of dimension item IDs flagged for removal
	local perimSnaps = {}; -- list of items to be placed within the perimeter
	local flagMatchKeep = {}; -- list of snapshot IDs that match items already in the dimension

	-- Snapshot perimeter check
	for k,v in pairs(tLoad) do
		if dcl.InPerimeter(v.coordX,v.coordY,v.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,args.perimeter) then
			table.insert(perimSnaps,v);
		end
	end

	-- Dimension items perimeter check
	local itemList = Inspect.Dimension.Layout.List();

	for k,v in pairs (itemList) do
		if v==false then
			local item = Inspect.Dimension.Layout.Detail(k);
			if item ~= nil then
				-- Check within perimeter
				if dcl.InPerimeter(item.coordX,item.coordY,item.coordZ,playerInfo.coordX,playerInfo.coordY,playerInfo.coordZ,args.perimeter) then
					-- Look to see if item should be placed as part of the set, if not then flag for removal.
					local perimSnapKey = dcl.GetItemKey(item.id,perimSnaps);
					if perimSnapKey == nil then
						table.insert(flagRemove,k);
					else
						table.insert(flagMatchKeep,perimSnapKey);
					end
				end
			end
		end
	end

	if #flagRemove > 0 then
		-- Prompt for removal of these items before continuing.

		for k,v in pairs (flagRemove) do
			print(tagText(Inspect.Dimension.Layout.Detail(v).name,"Red"));
		end

		for k,v in pairs (flagMatchKeep) do
			print(tagText(perimSnaps[v].name,"Yellow"));
		end

		local msg = MessageBox(dcl.GetString(57),MBOKCANCEL);
		msg.ButtonClick = function (sender,args)
			if args.Button == MBOK then
				dcl.Load_RemoveItems(flagRemove,perimSnaps,flagMatchKeep)
			else
				dcl.Load_FilterTables(perimSnaps,flagMatchKeep);
			end
		end
	else
		dcl.Load_FilterTables(perimSnaps,flagMatchKeep);
	end

end


function dcl.Load_RemoveItems(flaggedItems,perimSnaps,flagMatchKeep)
	-- User selected to remove flagged items, do this before continuing.
	dcl.Remove_Co = coroutine.create( function ()
		for k,v in pairs(flaggedItems) do
			local item = Inspect.Dimension.Layout.Detail(v);
			if item ~= nil and item.selected == nil then
				Command.Dimension.Layout.Pickup(v);
				coroutine.yield();
			end
		end
		dcl.Load_FilterTables(perimSnaps,flagMatchKeep);
	end);
	coroutine.resume(dcl.Remove_Co);
end


function dcl.Load_FilterTables(perimSnaps,flagMatchKeep)
	-- Strips matching items from the loading snapshot
	if #flagMatchKeep == 0 then dcl.Load_CheckSpace(perimSnaps) return end;
	--local filterTable = {};
	--[[
	for k,v in pairs(perimSnaps) do
		local match = false;
		for key,perimSnapKey in pairs (flagMatchKeep) do
			if v == perimSnapKey then match = true end;
			print(v.id.." - "..perimSnapKey.." - "..tostring(match));
		end
		if match == false then table.insert(filterTable,v) end;
	end
	--]]

	for k,v in pairs (flagMatchKeep) do
		perimSnaps[v] = nil;
	end

	dcl.Load_CheckSpace(perimSnaps);
end


function dcl.Load_CheckSpace(filterTable)
	-- Check dimension space vs items to be added.
	local spaceNeeded = dcl.GetDimensionSize() + #filterTable;

	local message = dcl.GetString(58);
	message = string.gsub(message,"<var>",#filterTable,1);
	message = string.gsub(message,"<var>",spaceNeeded,1);

	-- Prompt space check before continuing.
	local msg = MessageBox(message,MBOKCANCEL);
	msg.ButtonClick = function (sender,args)
		if args.Button == MBOK then
			dcl.Load_GetInventory(filterTable);
		end
	end
end


function dcl.Load_GetInventory(filterTable)
	-- Checks inventory availability from selected sources.
	local listTypes = dcl.GetDimensionItemList(filterTable);
	local tAvail = {};
	dcl.Avail_Co = coroutine.create( function ()
		for k,v in pairs (listTypes) do
			tAvail[k] = dcl.GetItemAvailability(k);
			coroutine.yield();
		end
		dcl.Load_CheckInventory(filterTable,tAvail,listTypes);
	end);
	coroutine.resume(dcl.Avail_Co);
end


function dcl.Load_CheckInventory(filterTable,tAvail,listTypes)
	-- Flag any missing items needed for the build and prompt user
	local flagMissing = {};
	for k,v in pairs (listTypes) do
		local qtyAvail = 0;
		--if (DimSnap_Settings.Load.Crate) then qtyAvail = qtyAvail + tAvail[k].Crate end;
		if (DimSnap_Settings.Load.Bags) then qtyAvail = qtyAvail + tAvail[k].Bags end;
		--if (DimSnap_Settings.Load.Guild) then qtyAvail = qtyAvail + tAvail[k].Guild end;
		if (DimSnap_Settings.Load.Bank) then qtyAvail = qtyAvail + tAvail[k].Bank + tAvail[k].Vault end;
		if qtyAvail < v then
			table.insert(flagMissing,{ ["Name"]=Inspect.Item.Detail(k).name; ["Needed"]=v; ["Available"]=qtyAvail; });
		end
	end

	if #flagMissing > 0 then
		local msg = MessageBox(dcl.GetString(73));
		for k,v in pairs (flagMissing) do
			print(tagText(v.Name..":","Yellow"));
			local message = dcl.GetString(74);
			message = string.gsub(message,"<var>",tostring(v.Needed),1); -- Required
			message = string.gsub(message,"<var>",tostring(v.Available),1); -- Available
			message = string.gsub(message,"<var>",tostring(v.Needed - v.Available),1); -- Need
			print(message);
		end
	else
		dcl.LoadSnapshot(filterTable);
	end
end


function dcl.LoadSnapshot(filterTable)
	-- Place necessary items
	print(tagText(dcl.GetString(59),"Cyan")); -- Checks complete

	dcl.ResetSnapshot(); -- Reset snapshots (to prevent any future problems)

	local notPlaced = {};

	---[[
	dcl.Restore_Co = coroutine.create( function ()
		for k,v in pairs(filterTable) do
			local placed = dcl.PlaceInvItem(v.type,v);
			if placed == false then
				if notPlaced[v.type] == nil then notPlaced[v.type] = 1 else notPlaced[v.type] = notPlaced[v.type] + 1 end;
			else
				coroutine.yield();
			end
		end
		dcl.VerifyLoad(notPlaced);
		end);
	coroutine.resume(dcl.Restore_Co);
	--]]

end


function dcl.VerifyLoad(notPlaced)
	-- Verify load by comparing the loaded set against the dimension
	-- if any items are flagged as missing, print a list of these items
	local errorPlace = false;

	for k,v in pairs(notPlaced) do
		local itemName = Inspect.Item.Detail(k).name;
		print(tagText(dcl.GetString(76)..v.."x "..itemName,"Red"));
		errorPlace = true;
	end

	if errorPlace == true then
		print(dcl.GetString(77));
	end

	print(tagText(dcl.GetString(60),"Cyan")); -- load complete

end

